defmodule ArkePostgres.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  import Ecto.Adapters.SQL.Sandbox
  use Application

  @impl true
  def start(type, args) do
    children = [
      {ArkePostgres.Repo, [show_sensitive_data_on_connection_error: true]}
      # Starts a worker by calling: ArkePostgres.Worker.start_link(arg)
      # {ArkePostgres.Worker, arg}
    ]

    # See https://hexdocs.pm/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: ArkePostgres.Supervisor]
    link = Supervisor.start_link(children, opts)

    ArkePostgres.init()

    link
  end

  # defp init_arke_postgres()
end
