defmodule ArkePostgres.Tables.ArkeField do
  use Ecto.Schema
  import Ecto.Changeset

  @arke_field_fields ~w[id label type format configuration]a
  @timestamps ~w[inserted_at updated_at]a

  @primary_key {:id, :string, []}
  schema "arke_field" do
    field(:label, :string)
    field(:type, :string, default: "string")
    field(:format, :string, default: "attribute")
    field(:configuration, :map, default: %{})
    field(:is_primary, :boolean, default: false)

    timestamps()
  end

  def changeset(arke_field, args) do
    arke_field
    |> cast(args, @arke_field_fields ++ @timestamps)
    |> validate_required(@arke_field_fields ++ @timestamps)
  end
end
