defmodule ArkePostgres.ArkeLink do
  use Ecto.Schema
  import Ecto.Changeset

  @arke_link_fields ~w[type parent_id child_id configuration]a

  @foreign_key_type :string
  schema "arke_link" do
    field(:type, :string, default: "link")
    belongs_to(:parent_id, ArkePostgres.ArkeUnit, primary_key: true)
    belongs_to(:child_id, ArkePostgres.ArkeUnit, primary_key: true)
    field(:configuration, :map, default: %{}, primary_key: true)
  end

  def changeset(args \\ []) do
    %__MODULE__{}
    |> cast(args, @arke_link_fields)
    |> validate_required(@arke_link_fields)
  end
end
